local _, ns = ...
local B, C, L, DB = unpack(ns)
local P = B:GetModule("Plus")

local _G = getfenv(0)
local select = select

function P:TradeLog()
	if not IsAddOnLoaded("TradeLog") then return end

	B.ReskinCheck(TBT_AnnounceCB)
	B.ReskinDropDown(TBT_AnnounceChannelDropDown)
	UIDropDownMenu_SetWidth(TBT_AnnounceChannelDropDown, 60)

	B.StripTextures(TradeListFrame)
	B.SetBD(TradeListFrame)
	B.Reskin(TradeListKeepOnlyTodayButton)
	B.ReskinClose(TradeListFrameClose)
	B.ReskinCheck(TradeListOnlyCompleteCB)
	B.ReskinSlider(TradeLogFrameScaleSlider)
	B.ReskinScroll(TradeListScrollFrameScrollBar)
	TradeListScrollFrameScrollBar:SetBackdrop(nil)
	TradeListScrollFrameScrollBar.SetBackdrop = B.Dummy

	for i = 1, 6 do
		local header = _G["TradeListFrameColumnHeader"..i]
		B.StripTextures(header)
	end

	B.StripTextures(TradeLogFrame)
	B.SetBD(TradeLogFrame)
	B.ReskinClose(TradeLogFrameClose)
	TradeLogFrame:EnableMouse(true)
	TradeLogFrame:SetMovable(true)
	TradeLogFrame:SetClampedToScreen(true)
	TradeLogFrame:HookScript("OnMouseDown", function(self, button)
		if button == "LeftButton" then
			self:StartMoving()
			self:SetUserPlaced(false)
		end
	end)
	TradeLogFrame:HookScript("OnMouseUp", function(self, button)
		if button == "LeftButton" then
			self:StopMovingOrSizing()
		end
	end)

	local function reskinButton(bu)
		_G[bu:GetName().."IconTexture"]:SetTexCoord(.08, .92, .08, .92)
		bu:GetHighlightTexture():SetColorTexture(1, 1, 1, .25)
		B.CreateBDFrame(bu, .25)
		local bd = B.CreateBDFrame(bu, .25)
		bd:SetPoint("TOPLEFT", bu, "TOPRIGHT")
		bd:SetPoint("BOTTOMRIGHT", 80, 0)
	end

	for i = 1, MAX_TRADE_ITEMS do
		_G["TradeLogPlayerItem"..i.."SlotTexture"]:Hide()
		_G["TradeLogPlayerItem"..i.."NameFrame"]:Hide()
		_G["TradeLogRecipientItem"..i.."SlotTexture"]:Hide()
		_G["TradeLogRecipientItem"..i.."NameFrame"]:Hide()

		reskinButton(_G["TradeLogPlayerItem"..i.."ItemButton"])
		reskinButton(_G["TradeLogRecipientItem"..i.."ItemButton"])
	end

	if not TBTFrame then return end -- version check

	B.Reskin(TradeFrameTargetWhisperButton)
	B.Reskin(TradeFrameTargetEmote1Button)
	B.Reskin(TradeFrameTargetEmote2Button)

	for i = 1, TradeFrame:GetNumRegions() do
		local region = select(i, TradeFrame:GetRegions())
		if region:GetObjectType() == "FontString" and region:GetName() == nil then
			region:Hide()
		end
	end

	local buttons = {"TradeFramePlayerSpell1Button", "TradeFramePlayerSpell2Button", "TradeFramePlayerSpell3Button"}
	for _, button in next, buttons do
		local bu = _G[button]
		if bu then
			bu:GetNormalTexture():SetTexCoord(.08, .92, .08, .92)
			B.CreateBDFrame(bu)
		end
	end
end
