local _, ns = ...
local B, C, L, DB = unpack(ns)
local P = B:GetModule("Plus")

local _G = getfenv(0)
local select = select

function P:alaGearMan()
	if not IsAddOnLoaded("alaGearMan") then return end
	if not NDuiPlusDB["alaGearMan"] then return end

	local gearWin, custom, statPanel
	local gearWidth = 200
	local texture_delete = "Interface\\Buttons\\UI-GroupLoot-Pass-Up"
	local texture_modify = "Interface\\WorldMap\\GEAR_64GREY"
	local texture_up = "Interface\\AddOns\\NDui_Plus\\Media\\arrow-up"
	local texture_down = "Interface\\AddOns\\NDui_Plus\\Media\\arrow-down"

	local function ReskinQuick()
		for i = 1, 20 do
			local button = _G["alaGearMan_SecureQuick" .. i]
			if button and button.icon and not button.styled then
				B.ReskinIcon(button.icon)
				button.styled = true
			end
		end
	end

	hooksecurefunc(_G.AGM_FUNC, "initUI", function()
		for i = 1, PaperDollFrame:GetNumChildren() do
			local child = select(i, PaperDollFrame:GetChildren())
			if child:HasScript("OnClick") and child:GetScript("OnClick") == _G.AGM_FUNC.open_onclick then
				for index = 1, child:GetNumRegions() do
					local region = select(index, child:GetRegions())
					region:SetTexCoord(0.16, 0.86, 0.16, 0.86)
					region.SetTexCoord = B.Dummy
				end

				child:SetSize(24,24)
				child.bg = B.CreateBDFrame(child)
				child.bg:SetPoint("TOPLEFT", -1, 1)
				child.bg:SetPoint("BOTTOMRIGHT", 0, -2)
			end
		end

		for i = 1, gearWin:GetNumChildren() do
			local child = select(i, gearWin:GetChildren())
			if child:GetObjectType() == "Button" and child:GetText() then
				B.Reskin(child)
			end
			if child:HasScript("OnClick") and child:GetScript("OnClick") == _G.AGM_FUNC.setting then
				child:SetNormalTexture(texture_modify)
				child:SetPushedTexture(texture_modify)
				child:GetPushedTexture():SetVertexColor(0.25, 0.25, 0.25, 1.0)
			end
			if child.CustomShow then
				B.StripTextures(child)
				B.SetBD(child)
				child:EnableMouse(true)
				child:SetMovable(true)
				child:SetClampedToScreen(true)
				child:SetScript("OnMouseDown", function(self, button)
					if button == "LeftButton" then
						self:StartMoving()
						self:SetUserPlaced(false)
					end
				end)
				child:SetScript("OnMouseUp", function(self, button)
					if button == "LeftButton" then
						self:StopMovingOrSizing()
					end
				end)
				custom = child
			end
		end

		for i = 1, custom:GetNumChildren() do
			local child = select(i, custom:GetChildren())
			if child:GetObjectType() == "Button" and child:GetText() then
				B.Reskin(child)
			end
			if child:HasScript("OnEnterPressed") and child:HasScript("OnEscapePressed") then
				B.CreateSD(child)
			end
			if child:GetObjectType() == "Button" and child:GetNormalTexture() then
				child:GetNormalTexture():SetTexCoord(.08, .92, .08, .92)
				B.CreateBDFrame(child:GetNormalTexture(), .25)
			end
		end
		ReskinQuick()
	end)

	hooksecurefunc(_G.AGM_FUNC, "customOK", ReskinQuick)

	hooksecurefunc("ALASCR", function(parent, width, height, ...)
		if not width then return end

		local frame = parent
		frame:ClearAllPoints()
		frame:SetPoint("TOPLEFT", PaperDollFrame, "TOPRIGHT", -32, -15-C.mult)
		B.StripTextures(frame)
		gearWin = frame
		gearWidth = width + 20

		local bg = CreateFrame("Frame", nil, frame)
		bg:SetSize(gearWidth, 422)
		bg:SetPoint("TOPLEFT")
		bg:EnableMouse(true)
		bg:SetFrameLevel(frame:GetFrameLevel() - 1)
		B.SetBD(bg)
	end)

	local function delayFunc()
		for i = 1, PaperDollFrame:GetNumChildren() do
			local child = select(i, PaperDollFrame:GetChildren())
			for j = 1, child:GetNumChildren() do
				local child2 = select(j, child:GetChildren())
				if child2.ScrollBar then
					statPanel = child
				end
			end
		end
	end

	if IsAddOnLoaded("CharacterStatsClassic") then
		C_Timer.After(.5, delayFunc)
	end

	local function TogglestatPanel(a)
		if not statPanel then P:Debug("not statPanel") return end
		statPanel:SetAlpha(a)
	end

	local function ToggleinspectFrame(xOffset)
		if not PaperDollFrame.inspectFrame then P:Debug("not PaperDollFrame.inspectFrame") return end
		if xOffset == 0 and statPanel and statPanel:IsShown() then 
			xOffset = statPanel:GetWidth() + 3
		end
		PaperDollFrame.inspectFrame:SetPoint("TOPLEFT", PaperDollFrame, "TOPRIGHT", -33 + xOffset, -15)
	end

	if IsAddOnLoaded("MerInspect") then
		hooksecurefunc("ShowInspectItemListFrame", function(_, parent)
			local frame = parent.inspectFrame
			if not frame then return end
			local f = parent:GetName()
    		if f == "PaperDollFrame" and gearWin and gearWin:IsShown() then
				ToggleinspectFrame(gearWidth + 3)
    		end
		end)
	end

	local function gearWinShow()
		P:Debug("gearWin Show")
		ToggleinspectFrame(gearWidth + 3)
		TogglestatPanel(0)
	end

	local function gearWinHide()
		P:Debug("gearWin Hide")
		ToggleinspectFrame(0)
		TogglestatPanel(1)
	end

	local done
	PaperDollFrame:HookScript("OnShow", function()
		P:Debug("PaperDollFrame OnShow")
		if done then return end
		if not gearWin then P:Debug("not gearWin") return end
		gearWin:HookScript("OnShow", gearWinShow)
		gearWin:HookScript("OnHide", gearWinHide)
		P:Debug("gearWin HookScript")
		done = true
	end)

	hooksecurefunc(_G.AGM_FUNC, "gm_SetButton", function(button, index)
		if button.icon and not button.styled then
			button.icon:SetTexCoord(.08, .92, .08, .92)
			B.CreateBDFrame(button.icon, .25)
			button.delete:SetNormalTexture(texture_delete)
			button.delete:SetPushedTexture(texture_delete)
			button.modify:SetNormalTexture(texture_modify)
			button.modify:SetPushedTexture(texture_modify)
			button.modify:SetSize(button.delete:GetWidth() + 2, button.delete:GetHeight() + 2)
			button.modify:SetPoint("BOTTOMRIGHT", -3.2, 2)
			button.up:SetNormalTexture(texture_up)
			button.up:SetPushedTexture(texture_up)
			button.up:SetDisabledTexture(texture_up)
			button.up:GetNormalTexture():SetTexCoord(6 / 32, 25 / 32, 7 / 32, 24 / 32)
			button.up:GetPushedTexture():SetTexCoord(6 / 32, 25 / 32, 7 / 32, 24 / 32)
			button.up:GetDisabledTexture():SetTexCoord(6 / 32, 25 / 32, 7 / 32, 24 / 32)
			button.down:SetNormalTexture(texture_down)
			button.down:SetPushedTexture(texture_down)
			button.down:SetDisabledTexture(texture_down)
			button.down:GetNormalTexture():SetTexCoord(6 / 32, 25 / 32, 7 / 32, 24 / 32)
			button.down:GetPushedTexture():SetTexCoord(6 / 32, 25 / 32, 7 / 32, 24 / 32)
			button.down:GetDisabledTexture():SetTexCoord(6 / 32, 25 / 32, 7 / 32, 24 / 32)
			button.helmet:SetSize(16, 16)
			B.ReskinRadio(button.helmet)
			button.cloak:SetSize(16, 16)
			B.ReskinRadio(button.cloak)
			button.styled = true
		end
	end)

	local pdf_menu
	hooksecurefunc(_G.AGM_FUNC, "pdf_init", function()
		for i = 1, PaperDollFrame:GetNumChildren() do
			local child = select(i, PaperDollFrame:GetChildren())
			if child:GetObjectType() == "Frame" and child:GetFrameStrata() == "FULLSCREEN_DIALOG" and child:HasScript("OnUpdate") then
				B.SetBD(child, -2, 2, 2, -2)
				pdf_menu = child
				break
			end
		end
	end)

	local function hook_SetNormalTexture(self, texture)
		if self.settingTexture then return end
		self.settingTexture = true
		self:SetNormalTexture("")

		if texture and texture ~= "" then
			self.Icon:SetTexture(texture)
			self.bg:Show()
		else
			self.bg:Hide()
		end
		self.settingTexture = nil
	end

	local function hook_SetVertexColor(self, r, g, b)
		self:GetParent().bg:SetBackdropBorderColor(r, g, b)
	end
	local function hook_Hide(self)
		self:GetParent().bg:SetBackdropBorderColor(0, 0, 0)
	end

	hooksecurefunc(_G.AGM_FUNC, "pdf_CreateButton", function(index)
		if not pdf_menu then return end
		for i = 1, pdf_menu:GetNumChildren() do
			local child = select(i, pdf_menu:GetChildren())
			if child:GetObjectType() == "Button" and not child.styled then
				child.bg = B.CreateBDFrame(child)
				child.bg:SetPoint("TOPLEFT", 0, 0)
				child.bg:SetPoint("BOTTOMRIGHT", 0, 0)

				child.Icon = child:CreateTexture(nil, "ARTWORK")
				child.Icon:SetPoint("TOPLEFT", C.mult, -C.mult)
				child.Icon:SetPoint("BOTTOMRIGHT", -C.mult, C.mult)
				child.Icon:SetTexCoord(unpack(DB.TexCoord))

				hooksecurefunc(child, "SetNormalTexture", hook_SetNormalTexture)
				child:SetPushedTexture("")
				child.SetPushedTexture = B.Dummy
				child:GetHighlightTexture():SetColorTexture(1, 1, 1, .25)

				child.glow:SetAlpha(0)
				hooksecurefunc(child.glow, "SetVertexColor", hook_SetVertexColor)
				hooksecurefunc(child.glow, "Hide", hook_Hide)
				child.styled = true
			end
		end
	end)
end
